Merge 'normalize-win-paths' into HEAD
[git/mingw/4msysgit.git] / git-submodule.sh
blob4e1815452026315978db33f0e4019ea883e20666
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 command=
26 branch=
27 force=
28 reference=
29 cached=
30 recursive=
31 init=
32 files=
33 remote=
34 nofetch=
35 update=
36 prefix=
37 custom_name=
38 depth=
40 # The function takes at most 2 arguments. The first argument is the
41 # URL that navigates to the submodule origin repo. When relative, this URL
42 # is relative to the superproject origin URL repo. The second up_path
43 # argument, if specified, is the relative path that navigates
44 # from the submodule working tree to the superproject working tree.
46 # The output of the function is the origin URL of the submodule.
48 # The output will either be an absolute URL or filesystem path (if the
49 # superproject origin URL is an absolute URL or filesystem path,
50 # respectively) or a relative file system path (if the superproject
51 # origin URL is a relative file system path).
53 # When the output is a relative file system path, the path is either
54 # relative to the submodule working tree, if up_path is specified, or to
55 # the superproject working tree otherwise.
56 resolve_relative_url ()
58 remote=$(get_default_remote)
59 remoteurl=$(git config "remote.$remote.url") ||
60 remoteurl=$(pwd) # the repository is its own authoritative upstream
61 url="$1"
62 remoteurl=${remoteurl%/}
63 sep=/
64 up_path="$2"
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
70 ./*|../*)
71 is_relative=t
74 is_relative=t
75 remoteurl="./$remoteurl"
77 esac
79 while test -n "$url"
81 case "$url" in
82 ../*)
83 url="${url#../}"
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
100 esac
102 ./*)
103 url="${url#./}"
106 break;;
107 esac
108 done
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
113 # Resolve a path to be relative to another path. This is intended for
114 # converting submodule paths when git-submodule is run in a subdirectory
115 # and only handles paths where the directory separator is '/'.
117 # The output is the first argument as a path relative to the second argument,
118 # which defaults to $wt_prefix if it is omitted.
119 relative_path ()
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
127 while test -n "$curdir"
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
134 esac
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
143 done
145 echo "$result$target"
149 # Get submodule info for registered submodules
150 # $@ = path to limit submodule list
152 module_list()
154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
156 git ls-files -z --error-unmatch --stage -- "$@" ||
157 echo "unmatched pathspec exists"
159 @@PERL@@ -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
162 my @out = ();
163 my $unmatched = 0;
164 $/ = "\0";
165 while (<STDIN>) {
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
176 push @out, "$mode $null_sha1 U\t$path\n";
178 next;
180 push @out, "$_\n";
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
190 die_if_unmatched ()
192 if test "$1" = "#unmatched"
193 then
194 exit 1
199 # Print a submodule configuration setting
201 # $1 = submodule name
202 # $2 = option name
203 # $3 = default value
205 # Checks in the usual git-config places first (for overrides),
206 # otherwise it falls back on .gitmodules. This allows you to
207 # distribute project-wide defaults in .gitmodules, while still
208 # customizing individual repositories if necessary. If the option is
209 # not in .gitmodules either, print a default value.
211 get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
220 printf '%s' "${value:-$default}"
225 # Map submodule path to submodule name
227 # $1 = path
229 module_name()
231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
232 sm_path="$1"
233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
236 test -z "$name" &&
237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
238 echo "$name"
242 # Clone a submodule
244 # Prior to calling, cmd_update checks that a possibly existing
245 # path is not a git repository.
246 # Likewise, cmd_add checks that path does not exist at all,
247 # since it is the location of a new submodule.
249 module_clone()
251 sm_path=$1
252 name=$2
253 url=$3
254 reference="$4"
255 depth="$5"
256 quiet=
257 if test -n "$GIT_QUIET"
258 then
259 quiet=-q
262 gitdir=
263 gitdir_base=
264 base_name=$(dirname "$name")
266 gitdir=$(git rev-parse --git-dir)
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
270 if test -d "$gitdir"
271 then
272 mkdir -p "$sm_path"
273 rm -f "$gitdir/index"
274 else
275 mkdir -p "$gitdir_base"
277 clear_local_git_env
278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
280 ) ||
281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
288 # Remove all common leading directories after a sanity check
289 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
290 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
292 while test "${a%%/*}" = "${b%%/*}"
294 a=${a#*/}
295 b=${b#*/}
296 done
297 # Now chop off the trailing '/'s that were added in the beginning
298 a=${a%/}
299 b=${b%/}
301 # Turn each leading "*/" component into "../"
302 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
303 echo "gitdir: $rel/$a" >"$sm_path/.git"
305 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
306 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
309 isnumber()
311 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
315 # Add a new submodule to the working tree, .gitmodules and the index
317 # $@ = repo path
319 # optional branch is stored in global branch variable
321 cmd_add()
323 # parse $args after "submodule ... add".
324 reference_path=
325 while test $# -ne 0
327 case "$1" in
328 -b | --branch)
329 case "$2" in '') usage ;; esac
330 branch=$2
331 shift
333 -f | --force)
334 force=$1
336 -q|--quiet)
337 GIT_QUIET=1
339 --reference)
340 case "$2" in '') usage ;; esac
341 reference_path=$2
342 shift
344 --reference=*)
345 reference_path="${1#--reference=}"
347 --name)
348 case "$2" in '') usage ;; esac
349 custom_name=$2
350 shift
352 --depth)
353 case "$2" in '') usage ;; esac
354 depth="--depth=$2"
355 shift
357 --depth=*)
358 depth=$1
361 shift
362 break
365 usage
368 break
370 esac
371 shift
372 done
374 if test -n "$reference_path"
375 then
376 is_absolute_path "$reference_path" ||
377 reference_path="$wt_prefix$reference_path"
379 reference="--reference=$reference_path"
382 repo=$1
383 sm_path=$2
385 if test -z "$sm_path"; then
386 sm_path=$(echo "$repo" |
387 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
390 if test -z "$repo" -o -z "$sm_path"; then
391 usage
394 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
396 # assure repo is absolute or relative to parent
397 case "$repo" in
398 ./*|../*)
399 test -z "$wt_prefix" ||
400 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
402 # dereference source url relative to parent's url
403 realrepo=$(resolve_relative_url "$repo") || exit
405 *:*|/*)
406 # absolute url
407 realrepo=$repo
410 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
412 esac
414 # normalize path:
415 # multiple //; leading ./; /./; /../; trailing /
416 sm_path=$(printf '%s/\n' "$sm_path" |
417 sed -e '
418 s|//*|/|g
419 s|^\(\./\)*||
420 s|/\./|/|g
421 :start
422 s|\([^/]*\)/\.\./||
423 tstart
424 s|/*$||
426 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
427 die "$(eval_gettext "'\$sm_path' already exists in the index")"
429 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
430 then
431 cat >&2 <<EOF
432 The following path is ignored by one of your .gitignore files:
433 $(eval_gettextln $sm_path)
434 Use -f if you really want to add it.
436 exit 1
439 if test -n "$custom_name"
440 then
441 sm_name="$custom_name"
442 else
443 sm_name="$sm_path"
446 # perhaps the path exists and is already a git repo, else clone it
447 if test -e "$sm_path"
448 then
449 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
450 then
451 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
452 else
453 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
456 else
457 if test -d ".git/modules/$sm_name"
458 then
459 if test -z "$force"
460 then
461 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
462 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
463 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
464 echo >&2 " $realrepo"
465 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
466 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
467 else
468 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
471 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
473 clear_local_git_env
474 cd "$sm_path" &&
475 # ash fails to wordsplit ${branch:+-b "$branch"...}
476 case "$branch" in
477 '') git checkout -f -q ;;
478 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
479 esac
480 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
482 git config submodule."$sm_name".url "$realrepo"
484 git add $force "$sm_path" ||
485 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
487 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
488 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
489 if test -n "$branch"
490 then
491 git config -f .gitmodules submodule."$sm_name".branch "$branch"
492 fi &&
493 git add --force .gitmodules ||
494 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
498 # Execute an arbitrary command sequence in each checked out
499 # submodule
501 # $@ = command to execute
503 cmd_foreach()
505 # parse $args after "submodule ... foreach".
506 while test $# -ne 0
508 case "$1" in
509 -q|--quiet)
510 GIT_QUIET=1
512 --recursive)
513 recursive=1
516 usage
519 break
521 esac
522 shift
523 done
525 toplevel=$(pwd)
527 # dup stdin so that it can be restored when running the external
528 # command in the subshell (and a recursive call to this function)
529 exec 3<&0
531 module_list |
532 while read mode sha1 stage sm_path
534 die_if_unmatched "$mode"
535 if test -e "$sm_path"/.git
536 then
537 displaypath=$(relative_path "$sm_path")
538 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
539 name=$(module_name "$sm_path")
541 prefix="$prefix$sm_path/"
542 clear_local_git_env
543 cd "$sm_path" &&
544 sm_path=$(relative_path "$sm_path") &&
545 # we make $path available to scripts ...
546 path=$sm_path &&
547 if test $# -eq 1
548 then
549 eval "$1"
550 else
551 "$@"
552 fi &&
553 if test -n "$recursive"
554 then
555 cmd_foreach "--recursive" "$@"
557 ) <&3 3<&- ||
558 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
560 done
564 # Register submodules in .git/config
566 # $@ = requested paths (default to all)
568 cmd_init()
570 # parse $args after "submodule ... init".
571 while test $# -ne 0
573 case "$1" in
574 -q|--quiet)
575 GIT_QUIET=1
578 shift
579 break
582 usage
585 break
587 esac
588 shift
589 done
591 module_list "$@" |
592 while read mode sha1 stage sm_path
594 die_if_unmatched "$mode"
595 name=$(module_name "$sm_path") || exit
597 displaypath=$(relative_path "$sm_path")
599 # Copy url setting when it is not set yet
600 if test -z "$(git config "submodule.$name.url")"
601 then
602 url=$(git config -f .gitmodules submodule."$name".url)
603 test -z "$url" &&
604 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
606 # Possibly a url relative to parent
607 case "$url" in
608 ./*|../*)
609 url=$(resolve_relative_url "$url") || exit
611 esac
612 git config submodule."$name".url "$url" ||
613 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
615 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
618 # Copy "update" setting when it is not set yet
619 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
620 test -n "$upd" &&
621 test -z "$(git config submodule."$name".update)"
622 then
623 case "$upd" in
624 checkout | rebase | merge | none)
625 ;; # known modes of updating
627 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
628 upd=none
630 esac
631 git config submodule."$name".update "$upd" ||
632 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
634 done
638 # Unregister submodules from .git/config and remove their work tree
640 # $@ = requested paths (use '.' to deinit all submodules)
642 cmd_deinit()
644 # parse $args after "submodule ... deinit".
645 while test $# -ne 0
647 case "$1" in
648 -f|--force)
649 force=$1
651 -q|--quiet)
652 GIT_QUIET=1
655 shift
656 break
659 usage
662 break
664 esac
665 shift
666 done
668 if test $# = 0
669 then
670 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
673 module_list "$@" |
674 while read mode sha1 stage sm_path
676 die_if_unmatched "$mode"
677 name=$(module_name "$sm_path") || exit
679 displaypath=$(relative_path "$sm_path")
681 # Remove the submodule work tree (unless the user already did it)
682 if test -d "$sm_path"
683 then
684 # Protect submodules containing a .git directory
685 if test -d "$sm_path/.git"
686 then
687 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
688 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
691 if test -z "$force"
692 then
693 git rm -qn "$sm_path" ||
694 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
696 rm -rf "$sm_path" &&
697 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
698 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
701 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
703 # Remove the .git/config entries (unless the user already did it)
704 if test -n "$(git config --get-regexp submodule."$name\.")"
705 then
706 # Remove the whole section so we have a clean state when
707 # the user later decides to init this submodule again
708 url=$(git config submodule."$name".url)
709 git config --remove-section submodule."$name" 2>/dev/null &&
710 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
712 done
716 # Update each submodule path to correct revision, using clone and checkout as needed
718 # $@ = requested paths (default to all)
720 cmd_update()
722 # parse $args after "submodule ... update".
723 while test $# -ne 0
725 case "$1" in
726 -q|--quiet)
727 GIT_QUIET=1
729 -i|--init)
730 init=1
732 --remote)
733 remote=1
735 -N|--no-fetch)
736 nofetch=1
738 -f|--force)
739 force=$1
741 -r|--rebase)
742 update="rebase"
744 --reference)
745 case "$2" in '') usage ;; esac
746 reference="--reference=$2"
747 shift
749 --reference=*)
750 reference="$1"
752 -m|--merge)
753 update="merge"
755 --recursive)
756 recursive=1
758 --checkout)
759 update="checkout"
761 --depth)
762 case "$2" in '') usage ;; esac
763 depth="--depth=$2"
764 shift
766 --depth=*)
767 depth=$1
770 shift
771 break
774 usage
777 break
779 esac
780 shift
781 done
783 if test -n "$init"
784 then
785 cmd_init "--" "$@" || return
788 cloned_modules=
789 module_list "$@" | {
790 err=
791 while read mode sha1 stage sm_path
793 die_if_unmatched "$mode"
794 if test "$stage" = U
795 then
796 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
797 continue
799 name=$(module_name "$sm_path") || exit
800 url=$(git config submodule."$name".url)
801 branch=$(get_submodule_config "$name" branch master)
802 if ! test -z "$update"
803 then
804 update_module=$update
805 else
806 update_module=$(git config submodule."$name".update)
807 case "$update_module" in
809 ;; # Unset update mode
810 checkout | rebase | merge | none)
811 ;; # Known update modes
813 ;; # Custom update command
815 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
817 esac
820 displaypath=$(relative_path "$prefix$sm_path")
822 if test "$update_module" = "none"
823 then
824 echo "Skipping submodule '$displaypath'"
825 continue
828 if test -z "$url"
829 then
830 # Only mention uninitialized submodules when its
831 # path have been specified
832 test "$#" != "0" &&
833 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
834 Maybe you want to use 'update --init'?")"
835 continue
838 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
839 then
840 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
841 cloned_modules="$cloned_modules;$name"
842 subsha1=
843 else
844 subsha1=$(clear_local_git_env; cd "$sm_path" &&
845 git rev-parse --verify HEAD) ||
846 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
849 if test -n "$remote"
850 then
851 if test -z "$nofetch"
852 then
853 # Fetch remote before determining tracking $sha1
854 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
855 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
857 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
858 sha1=$(clear_local_git_env; cd "$sm_path" &&
859 git rev-parse --verify "${remote_name}/${branch}") ||
860 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
863 if test "$subsha1" != "$sha1" -o -n "$force"
864 then
865 subforce=$force
866 # If we don't already have a -f flag and the submodule has never been checked out
867 if test -z "$subsha1" -a -z "$force"
868 then
869 subforce="-f"
872 if test -z "$nofetch"
873 then
874 # Run fetch only if $sha1 isn't present or it
875 # is not reachable from a ref.
876 (clear_local_git_env; cd "$sm_path" &&
877 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
878 test -z "$rev") || git-fetch)) ||
879 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
882 # Is this something we just cloned?
883 case ";$cloned_modules;" in
884 *";$name;"*)
885 # then there is no local change to integrate
886 update_module= ;;
887 esac
889 must_die_on_failure=
890 case "$update_module" in
891 rebase)
892 command="git rebase"
893 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
894 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
895 must_die_on_failure=yes
897 merge)
898 command="git merge"
899 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
900 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
901 must_die_on_failure=yes
904 command="${update_module#!}"
905 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
906 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
907 must_die_on_failure=yes
910 command="git checkout $subforce -q"
911 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
912 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
914 esac
916 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
917 then
918 say "$say_msg"
919 elif test -n "$must_die_on_failure"
920 then
921 die_with_status 2 "$die_msg"
922 else
923 err="${err};$die_msg"
924 continue
928 if test -n "$recursive"
929 then
931 prefix="$prefix$sm_path/"
932 clear_local_git_env
933 cd "$sm_path" &&
934 eval cmd_update
936 res=$?
937 if test $res -gt 0
938 then
939 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
940 if test $res -eq 1
941 then
942 err="${err};$die_msg"
943 continue
944 else
945 die_with_status $res "$die_msg"
949 done
951 if test -n "$err"
952 then
953 OIFS=$IFS
954 IFS=';'
955 for e in $err
957 if test -n "$e"
958 then
959 echo >&2 "$e"
961 done
962 IFS=$OIFS
963 exit 1
968 set_name_rev () {
969 revname=$( (
970 clear_local_git_env
971 cd "$1" && {
972 git describe "$2" 2>/dev/null ||
973 git describe --tags "$2" 2>/dev/null ||
974 git describe --contains "$2" 2>/dev/null ||
975 git describe --all --always "$2"
978 test -z "$revname" || revname=" ($revname)"
981 # Show commit summary for submodules in index or working tree
983 # If '--cached' is given, show summary between index and given commit,
984 # or between working tree and given commit
986 # $@ = [commit (default 'HEAD'),] requested paths (default all)
988 cmd_summary() {
989 summary_limit=-1
990 for_status=
991 diff_cmd=diff-index
993 # parse $args after "submodule ... summary".
994 while test $# -ne 0
996 case "$1" in
997 --cached)
998 cached="$1"
1000 --files)
1001 files="$1"
1003 --for-status)
1004 for_status="$1"
1006 -n|--summary-limit)
1007 summary_limit="$2"
1008 isnumber "$summary_limit" || usage
1009 shift
1011 --summary-limit=*)
1012 summary_limit="${1#--summary-limit=}"
1013 isnumber "$summary_limit" || usage
1016 shift
1017 break
1020 usage
1023 break
1025 esac
1026 shift
1027 done
1029 test $summary_limit = 0 && return
1031 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1032 then
1033 head=$rev
1034 test $# = 0 || shift
1035 elif test -z "$1" -o "$1" = "HEAD"
1036 then
1037 # before the first commit: compare with an empty tree
1038 head=$(git hash-object -w -t tree --stdin </dev/null)
1039 test -z "$1" || shift
1040 else
1041 head="HEAD"
1044 if [ -n "$files" ]
1045 then
1046 test -n "$cached" &&
1047 die "$(gettext "The --cached option cannot be used with the --files option")"
1048 diff_cmd=diff-files
1049 head=
1052 cd_to_toplevel
1053 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1054 # Get modified modules cared by user
1055 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1056 sane_egrep '^:([0-7]* )?160000' |
1057 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1059 # Always show modules deleted or type-changed (blob<->module)
1060 test $status = D -o $status = T && echo "$sm_path" && continue
1061 # Respect the ignore setting for --for-status.
1062 if test -n "$for_status"
1063 then
1064 name=$(module_name "$sm_path")
1065 ignore_config=$(get_submodule_config "$name" ignore none)
1066 test $status != A -a $ignore_config = all && continue
1068 # Also show added or modified modules which are checked out
1069 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1070 echo "$sm_path"
1071 done
1074 test -z "$modules" && return
1076 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1077 sane_egrep '^:([0-7]* )?160000' |
1078 cut -c2- |
1079 while read mod_src mod_dst sha1_src sha1_dst status name
1081 if test -z "$cached" &&
1082 test $sha1_dst = 0000000000000000000000000000000000000000
1083 then
1084 case "$mod_dst" in
1085 160000)
1086 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1088 100644 | 100755 | 120000)
1089 sha1_dst=$(git hash-object $name)
1091 000000)
1092 ;; # removed
1094 # unexpected type
1095 eval_gettextln "unexpected mode \$mod_dst" >&2
1096 continue ;;
1097 esac
1099 missing_src=
1100 missing_dst=
1102 test $mod_src = 160000 &&
1103 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1104 missing_src=t
1106 test $mod_dst = 160000 &&
1107 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1108 missing_dst=t
1110 display_name=$(relative_path "$name")
1112 total_commits=
1113 case "$missing_src,$missing_dst" in
1115 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1118 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1120 t,t)
1121 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1124 errmsg=
1125 total_commits=$(
1126 if test $mod_src = 160000 -a $mod_dst = 160000
1127 then
1128 range="$sha1_src...$sha1_dst"
1129 elif test $mod_src = 160000
1130 then
1131 range=$sha1_src
1132 else
1133 range=$sha1_dst
1135 GIT_DIR="$name/.git" \
1136 git rev-list --first-parent $range -- | wc -l
1138 total_commits=" ($(($total_commits + 0)))"
1140 esac
1142 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1143 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1144 if test $status = T
1145 then
1146 blob="$(gettext "blob")"
1147 submodule="$(gettext "submodule")"
1148 if test $mod_dst = 160000
1149 then
1150 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1151 else
1152 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1154 else
1155 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1157 if test -n "$errmsg"
1158 then
1159 # Don't give error msg for modification whose dst is not submodule
1160 # i.e. deleted or changed to blob
1161 test $mod_dst = 160000 && echo "$errmsg"
1162 else
1163 if test $mod_src = 160000 -a $mod_dst = 160000
1164 then
1165 limit=
1166 test $summary_limit -gt 0 && limit="-$summary_limit"
1167 GIT_DIR="$name/.git" \
1168 git log $limit --pretty='format: %m %s' \
1169 --first-parent $sha1_src...$sha1_dst
1170 elif test $mod_dst = 160000
1171 then
1172 GIT_DIR="$name/.git" \
1173 git log --pretty='format: > %s' -1 $sha1_dst
1174 else
1175 GIT_DIR="$name/.git" \
1176 git log --pretty='format: < %s' -1 $sha1_src
1178 echo
1180 echo
1181 done
1184 # List all submodules, prefixed with:
1185 # - submodule not initialized
1186 # + different revision checked out
1188 # If --cached was specified the revision in the index will be printed
1189 # instead of the currently checked out revision.
1191 # $@ = requested paths (default to all)
1193 cmd_status()
1195 # parse $args after "submodule ... status".
1196 while test $# -ne 0
1198 case "$1" in
1199 -q|--quiet)
1200 GIT_QUIET=1
1202 --cached)
1203 cached=1
1205 --recursive)
1206 recursive=1
1209 shift
1210 break
1213 usage
1216 break
1218 esac
1219 shift
1220 done
1222 module_list "$@" |
1223 while read mode sha1 stage sm_path
1225 die_if_unmatched "$mode"
1226 name=$(module_name "$sm_path") || exit
1227 url=$(git config submodule."$name".url)
1228 displaypath=$(relative_path "$prefix$sm_path")
1229 if test "$stage" = U
1230 then
1231 say "U$sha1 $displaypath"
1232 continue
1234 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1235 then
1236 say "-$sha1 $displaypath"
1237 continue;
1239 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1240 then
1241 set_name_rev "$sm_path" "$sha1"
1242 say " $sha1 $displaypath$revname"
1243 else
1244 if test -z "$cached"
1245 then
1246 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1248 set_name_rev "$sm_path" "$sha1"
1249 say "+$sha1 $displaypath$revname"
1252 if test -n "$recursive"
1253 then
1255 prefix="$displaypath/"
1256 clear_local_git_env
1257 cd "$sm_path" &&
1258 eval cmd_status
1259 ) ||
1260 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1262 done
1265 # Sync remote urls for submodules
1266 # This makes the value for remote.$remote.url match the value
1267 # specified in .gitmodules.
1269 cmd_sync()
1271 while test $# -ne 0
1273 case "$1" in
1274 -q|--quiet)
1275 GIT_QUIET=1
1276 shift
1278 --recursive)
1279 recursive=1
1280 shift
1283 shift
1284 break
1287 usage
1290 break
1292 esac
1293 done
1294 cd_to_toplevel
1295 module_list "$@" |
1296 while read mode sha1 stage sm_path
1298 die_if_unmatched "$mode"
1299 name=$(module_name "$sm_path")
1300 url=$(git config -f .gitmodules --get submodule."$name".url)
1302 # Possibly a url relative to parent
1303 case "$url" in
1304 ./*|../*)
1305 # rewrite foo/bar as ../.. to find path from
1306 # submodule work tree to superproject work tree
1307 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1308 # guarantee a trailing /
1309 up_path=${up_path%/}/ &&
1310 # path from submodule work tree to submodule origin repo
1311 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1312 # path from superproject work tree to submodule origin repo
1313 super_config_url=$(resolve_relative_url "$url") || exit
1316 sub_origin_url="$url"
1317 super_config_url="$url"
1319 esac
1321 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1322 then
1323 displaypath=$(relative_path "$prefix$sm_path")
1324 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1325 git config submodule."$name".url "$super_config_url"
1327 if test -e "$sm_path"/.git
1328 then
1330 clear_local_git_env
1331 cd "$sm_path"
1332 remote=$(get_default_remote)
1333 git config remote."$remote".url "$sub_origin_url"
1335 if test -n "$recursive"
1336 then
1337 prefix="$prefix$sm_path/"
1338 eval cmd_sync
1343 done
1346 # This loop parses the command line arguments to find the
1347 # subcommand name to dispatch. Parsing of the subcommand specific
1348 # options are primarily done by the subcommand implementations.
1349 # Subcommand specific options such as --branch and --cached are
1350 # parsed here as well, for backward compatibility.
1352 while test $# != 0 && test -z "$command"
1354 case "$1" in
1355 add | foreach | init | deinit | update | status | summary | sync)
1356 command=$1
1358 -q|--quiet)
1359 GIT_QUIET=1
1361 -b|--branch)
1362 case "$2" in
1364 usage
1366 esac
1367 branch="$2"; shift
1369 --cached)
1370 cached="$1"
1373 break
1376 usage
1379 break
1381 esac
1382 shift
1383 done
1385 # No command word defaults to "status"
1386 if test -z "$command"
1387 then
1388 if test $# = 0
1389 then
1390 command=status
1391 else
1392 usage
1396 # "-b branch" is accepted only by "add"
1397 if test -n "$branch" && test "$command" != add
1398 then
1399 usage
1402 # "--cached" is accepted only by "status" and "summary"
1403 if test -n "$cached" && test "$command" != status -a "$command" != summary
1404 then
1405 usage
1408 "cmd_$command" "$@"